// Code generated by gowrap. DO NOT EDIT.
// template: ..\..\..\assets\templates\middleware\telemetry
// gowrap: http://github.com/hexdigest/gowrap

package middleware

//go:generate gowrap gen -p git.perx.ru/perxis/perxis-go/pkg/environments -i Environments -t ..\..\..\assets\templates\middleware\telemetry -o telemetry_middleware.go -l ""

// source template: https://github.com/hexdigest/gowrap/blob/master/templates/opentelemetry

import (
	"context"
	"time"

	"git.perx.ru/perxis/perxis-go/pkg/environments"
	"git.perx.ru/perxis/perxis-go/pkg/telemetry/metrics"
	"go.opentelemetry.io/otel"
	"go.opentelemetry.io/otel/attribute"
	otelmetric "go.opentelemetry.io/otel/metric"
	"go.opentelemetry.io/otel/trace"
)

// telemetryMiddleware implements environments.Environments interface instrumented with opentracing spans
type telemetryMiddleware struct {
	environments.Environments
	_instance      string
	requestMetrics *metrics.RequestMetrics
	_spanDecorator func(span trace.Span, params, results map[string]interface{})
}

// TelemetryMiddleware returns telemetryMiddleware
func TelemetryMiddleware(base environments.Environments, instance string, spanDecorator ...func(span trace.Span, params, results map[string]interface{})) telemetryMiddleware {
	requestMetrics, err := metrics.GetRequestMetrics()
	if err != nil {
		panic(err)
	}

	d := telemetryMiddleware{
		Environments:   base,
		_instance:      instance,
		requestMetrics: requestMetrics,
	}

	if len(spanDecorator) > 0 && spanDecorator[0] != nil {
		d._spanDecorator = spanDecorator[0]
	}

	return d
}

// Create implements environments.Environments
func (_d telemetryMiddleware) Create(ctx context.Context, env *environments.Environment) (created *environments.Environment, err error) {
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(
		attribute.String("service", "Environments"),
		attribute.String("method", "Create"),
	))

	_d.requestMetrics.Total.Add(ctx, 1, attributes)

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "Environments.Create")

	defer func() {
		_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

		if _d._spanDecorator != nil {
			_d._spanDecorator(_span, map[string]interface{}{
				"ctx": ctx,
				"env": env}, map[string]interface{}{
				"created": created,
				"err":     err})
		} else if err != nil {
			_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

			_span.RecordError(err)
			_span.SetAttributes(attribute.String("event", "error"))
			_span.SetAttributes(attribute.String("message", err.Error()))
		}

		_span.End()
	}()
	return _d.Environments.Create(ctx, env)
}

// Delete implements environments.Environments
func (_d telemetryMiddleware) Delete(ctx context.Context, spaceId string, envId string) (err error) {
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(
		attribute.String("service", "Environments"),
		attribute.String("method", "Delete"),
	))

	_d.requestMetrics.Total.Add(ctx, 1, attributes)

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "Environments.Delete")

	defer func() {
		_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

		if _d._spanDecorator != nil {
			_d._spanDecorator(_span, map[string]interface{}{
				"ctx":     ctx,
				"spaceId": spaceId,
				"envId":   envId}, map[string]interface{}{
				"err": err})
		} else if err != nil {
			_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

			_span.RecordError(err)
			_span.SetAttributes(attribute.String("event", "error"))
			_span.SetAttributes(attribute.String("message", err.Error()))
		}

		_span.End()
	}()
	return _d.Environments.Delete(ctx, spaceId, envId)
}

// Get implements environments.Environments
func (_d telemetryMiddleware) Get(ctx context.Context, spaceId string, envId string) (env *environments.Environment, err error) {
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(
		attribute.String("service", "Environments"),
		attribute.String("method", "Get"),
	))

	_d.requestMetrics.Total.Add(ctx, 1, attributes)

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "Environments.Get")

	defer func() {
		_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

		if _d._spanDecorator != nil {
			_d._spanDecorator(_span, map[string]interface{}{
				"ctx":     ctx,
				"spaceId": spaceId,
				"envId":   envId}, map[string]interface{}{
				"env": env,
				"err": err})
		} else if err != nil {
			_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

			_span.RecordError(err)
			_span.SetAttributes(attribute.String("event", "error"))
			_span.SetAttributes(attribute.String("message", err.Error()))
		}

		_span.End()
	}()
	return _d.Environments.Get(ctx, spaceId, envId)
}

// List implements environments.Environments
func (_d telemetryMiddleware) List(ctx context.Context, spaceId string) (envs []*environments.Environment, err error) {
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(
		attribute.String("service", "Environments"),
		attribute.String("method", "List"),
	))

	_d.requestMetrics.Total.Add(ctx, 1, attributes)

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "Environments.List")

	defer func() {
		_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

		if _d._spanDecorator != nil {
			_d._spanDecorator(_span, map[string]interface{}{
				"ctx":     ctx,
				"spaceId": spaceId}, map[string]interface{}{
				"envs": envs,
				"err":  err})
		} else if err != nil {
			_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

			_span.RecordError(err)
			_span.SetAttributes(attribute.String("event", "error"))
			_span.SetAttributes(attribute.String("message", err.Error()))
		}

		_span.End()
	}()
	return _d.Environments.List(ctx, spaceId)
}

// Migrate implements environments.Environments
func (_d telemetryMiddleware) Migrate(ctx context.Context, spaceId string, envId string, options ...*environments.MigrateOptions) (err error) {
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(
		attribute.String("service", "Environments"),
		attribute.String("method", "Migrate"),
	))

	_d.requestMetrics.Total.Add(ctx, 1, attributes)

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "Environments.Migrate")

	defer func() {
		_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

		if _d._spanDecorator != nil {
			_d._spanDecorator(_span, map[string]interface{}{
				"ctx":     ctx,
				"spaceId": spaceId,
				"envId":   envId,
				"options": options}, map[string]interface{}{
				"err": err})
		} else if err != nil {
			_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

			_span.RecordError(err)
			_span.SetAttributes(attribute.String("event", "error"))
			_span.SetAttributes(attribute.String("message", err.Error()))
		}

		_span.End()
	}()
	return _d.Environments.Migrate(ctx, spaceId, envId, options...)
}

// RemoveAlias implements environments.Environments
func (_d telemetryMiddleware) RemoveAlias(ctx context.Context, spaceId string, envId string, alias string) (err error) {
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(
		attribute.String("service", "Environments"),
		attribute.String("method", "RemoveAlias"),
	))

	_d.requestMetrics.Total.Add(ctx, 1, attributes)

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "Environments.RemoveAlias")

	defer func() {
		_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

		if _d._spanDecorator != nil {
			_d._spanDecorator(_span, map[string]interface{}{
				"ctx":     ctx,
				"spaceId": spaceId,
				"envId":   envId,
				"alias":   alias}, map[string]interface{}{
				"err": err})
		} else if err != nil {
			_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

			_span.RecordError(err)
			_span.SetAttributes(attribute.String("event", "error"))
			_span.SetAttributes(attribute.String("message", err.Error()))
		}

		_span.End()
	}()
	return _d.Environments.RemoveAlias(ctx, spaceId, envId, alias)
}

// SetAlias implements environments.Environments
func (_d telemetryMiddleware) SetAlias(ctx context.Context, spaceId string, envId string, alias string) (err error) {
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(
		attribute.String("service", "Environments"),
		attribute.String("method", "SetAlias"),
	))

	_d.requestMetrics.Total.Add(ctx, 1, attributes)

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "Environments.SetAlias")

	defer func() {
		_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

		if _d._spanDecorator != nil {
			_d._spanDecorator(_span, map[string]interface{}{
				"ctx":     ctx,
				"spaceId": spaceId,
				"envId":   envId,
				"alias":   alias}, map[string]interface{}{
				"err": err})
		} else if err != nil {
			_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

			_span.RecordError(err)
			_span.SetAttributes(attribute.String("event", "error"))
			_span.SetAttributes(attribute.String("message", err.Error()))
		}

		_span.End()
	}()
	return _d.Environments.SetAlias(ctx, spaceId, envId, alias)
}

// Update implements environments.Environments
func (_d telemetryMiddleware) Update(ctx context.Context, env *environments.Environment) (err error) {
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(
		attribute.String("service", "Environments"),
		attribute.String("method", "Update"),
	))

	_d.requestMetrics.Total.Add(ctx, 1, attributes)

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "Environments.Update")

	defer func() {
		_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

		if _d._spanDecorator != nil {
			_d._spanDecorator(_span, map[string]interface{}{
				"ctx": ctx,
				"env": env}, map[string]interface{}{
				"err": err})
		} else if err != nil {
			_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

			_span.RecordError(err)
			_span.SetAttributes(attribute.String("event", "error"))
			_span.SetAttributes(attribute.String("message", err.Error()))
		}

		_span.End()
	}()
	return _d.Environments.Update(ctx, env)
}
